## ros-kinetic-robotis-controller 0.2.9

=== CMakeLists.txt ===
################################################################################
# Set minimum required version of cmake, project name and compile options
################################################################################
cmake_minimum_required(VERSION 2.8.3)
project(robotis_controller)

## Compile as C++11, supported in ROS Kinetic and newer
add_compile_options(-std=c++11)

################################################################################
# Find catkin packages and libraries for catkin and system dependencies
################################################################################
find_package(catkin REQUIRED COMPONENTS
  roscpp
  roslib
  std_msgs
  sensor_msgs
  robotis_controller_msgs
  dynamixel_sdk
  robotis_device
  robotis_framework_common
  cmake_modules
)

find_package(Boost REQUIRED)

# Resolve system dependency on yaml-cpp, which apparently does not
# provide a CMake find_package() module.
find_package(PkgConfig REQUIRED)
pkg_check_modules(YAML_CPP REQUIRED yaml-cpp)
find_path(YAML_CPP_INCLUDE_DIR
  NAMES yaml_cpp.h
  PATHS ${YAML_CPP_INCLUDE_DIRS}
)
find_library(YAML_CPP_LIBRARY
  NAMES YAML_CPP
  PATHS ${YAML_CPP_LIBRARY_DIRS}
)
link_directories(${YAML_CPP_LIBRARY_DIRS})

if(NOT ${YAML_CPP_VERSION} VERSION_LESS "0.5")
add_definitions(-DHAVE_NEW_YAMLCPP)
endif(NOT ${YAML_CPP_VERSION} VERSION_LESS "0.5")

################################################################################
# Setup for python modules and scripts
################################################################################

################################################################################
# Declare ROS messages, services and actions
################################################################################

################################################################################
# Declare ROS dynamic reconfigure parameters
################################################################################

################################################################################
# Declare catkin specific configuration to be passed to dependent projects
################################################################################
catkin_package(
  INCLUDE_DIRS include
  LIBRARIES robotis_controller
  CATKIN_DEPENDS roscpp roslib std_msgs sensor_msgs robotis_controller_msgs dynamixel_sdk robotis_device robotis_framework_common cmake_modules
  DEPENDS Boost
)

################################################################################
# Build
################################################################################
include_directories(
  include
  ${catkin_INCLUDE_DIRS}
  ${Boost_INCLUDE_DIRS}
  ${YAML_CPP_INCLUDE_DIRS}
)

add_library(robotis_controller src/robotis_controller/robotis_controller.cpp)
add_dependencies(robotis_controller ${catkin_EXPORTED_TARGETS})
target_link_libraries(robotis_controller ${catkin_LIBRARIES} ${Boost_LIBRARIES} ${YAML_CPP_LIBRARIES})

################################################################################
# Install
################################################################################
install(TARGETS robotis_controller
  ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
)

install(DIRECTORY include/${PROJECT_NAME}/
  DESTINATION ${CATKIN_PACKAGE_INCLUDE_DESTINATION}
)

################################################################################
# Test
################################################################################

=== debian/changelog ===
ros-kinetic-robotis-controller (0.2.9-0xenial) xenial; urgency=high

  * added serivce for setting module
  * deleted comment for debug
  * modified to prevent duplicate indirect address write
  * added boost system dependencies
  * fixed a bug that occure when handling bulk read item that does not exist.
  * Contributors: Kayman, Zerom, Pyo

 -- Pyo <pyo@robotis.com>  Wed, 21 Mar 2018 15:00:00 -0000

ros-kinetic-robotis-controller (0.2.8-0xenial) xenial; urgency=high

  * modified CMakeLists.txt for system dependencies (yaml-cpp)
  * Contributors: Zerom, Pyo

 -- Pyo <pyo@robotis.com>  Mon, 19 Mar 2018 15:00:00 -0000

ros-kinetic-robotis-controller (0.2.7-0xenial) xenial; urgency=high

  * changed the License and package format to version 2
  * changed all values read by bulk read are saved to dxl_state_->bulk_read_table_.
  * Modified to prevent duplicate indirect address write
  * Contributors: SCH, Zerom, Pyo

 -- Pyo <pyo@robotis.com>  Wed, 14 Mar 2018 15:00:00 -0000

ros-kinetic-robotis-controller (0.2.6-0xenial) xenial; urgency=high

  * multi thread bug fixed.
  * unnecessary debug print removed.
  * OpenCR control table item name changed. (torque_enable -> dynamixel_power)
  * fixed to not update update_time_stamp_ if bulk read fails.
  * Contributors: Zerom

 -- Pyo <pyo@robotis.com>  Tue, 08 Aug 2017 15:00:00 -0000

ros-kinetic-robotis-controller (0.2.5-0xenial) xenial; urgency=high

  * updated for yaml-cpp dependencies
  * Contributors: SCH

 -- Pyo <pyo@robotis.com>  Thu, 08 Jun 2017 15:00:00 -0000

ros-kinetic-robotis-controller (0.2.4-0xenial) xenial; urgency=high

  * added cmake_modules in package.xml
  * Contributors: SCH

 -- Pyo <pyo@robotis.com>  Tue, 06 Jun 2017 15:00:00 -0000

ros-kinetic-robotis-controller (0.2.3-0xenial) xenial; urgency=high

  * updated the cmake file for ros install
  * Contributors: SCH

 -- Pyo <pyo@robotis.com>  Mon, 22 May 2017 15:00:00 -0000

ros-kinetic-robotis-controller (0.2.2-0xenial) xenial; urgency=high

  * updated robotis_controller.cpp
  * changed to read control cycle from .robot file
  * Contributors: Zerom

 -- Pyo <pyo@robotis.com>  Sun, 23 Apr 2017 15:00:00 -0000

ros-kinetic-robotis-controller (0.2.1-0xenial) xenial; urgency=high

  * Merge the changes and update
  * 
    
      * Direct Control Mode bug fixed.
    
  * update
  * 
    
      * added writeControlTableCallback
    
  * 
    
      * added WriteControlTable msg callback
    
  * mode change debugging
  * 
    
      * optimized cpu usage by spin loop (by astumpf)
    
  * 
    
      * robotis_controller process() : processing order changed.
    
    
      * 1st : packet communication
      * 2nd : processing modules
    
  * 
    
      * dependencies fixed. (Pull requests #26 <https://github.com/ROBOTIS-GIT/ROBOTIS-Framework/issues/26>)
    
  * 
    
      * make setJointCtrlModuleCallback() to the thread function & improved.
    
  * 
    
      * modified dependency problem.
    
  * 
    
      * reduce CPU consumption
    
  * Contributors: Jay Song, Pyo, Zerom, SCH

 -- Pyo <pyo@robotis.com>  Tue, 22 Nov 2016 15:00:00 -0000

ros-kinetic-robotis-controller (0.2.0-0xenial) xenial; urgency=high

  * bug fixed (position pid gain & velocity pid gain sync write).
  * added velocity_to_value_ratio to DXL Pro-H series.
  * changed some debug messages.
  * added velocity p/i/d gain and position i/d gain sync_write code.
  * SyncWriteItem bug fixed.
  * add function / modified the code simple (using auto / range based for loop)
  * added XM-430-W210 / XM-430-W350 device file.
  * rename ControlMode(CurrentControl -> TorqueControl)
  * rename (port_to_sync_write_torque_ -> port_to_sync_write_current_)
  * rename (present_current_ -> present_torque_)
  * modified torque control code
  * fixed typos / changed ROS_INFO -> fprintf (for processing speed)
  * startTimer() : after bulkread txpacket(), need some sleep()
  * changed the order of processing in the Process() function.
  * added missing mutex for gazebo
  * fixed crash when running in gazebo simulation
  * sync write bug fix.
  * added position_p_gain sync write
  * MotionModule/SensorModule member variable access changed (public -> protected).
  * Contributors: Jay Song, Zerom, Pyo, SCH

 -- Pyo <pyo@robotis.com>  Tue, 30 Aug 2016 15:00:00 -0000

ros-kinetic-robotis-controller (0.1.1-0xenial) xenial; urgency=high

  * updated the package information

 -- Pyo <pyo@robotis.com>  Wed, 17 Aug 2016 15:00:00 -0000

ros-kinetic-robotis-controller (0.1.0-0xenial) xenial; urgency=high

  * first public release for Kinetic
  * modified the package information for release
  * develop branch -> master branch
  * function name changed : DeviceInit() -> InitDevice()
  * Fixed high CPU consumption due to busy waits
  * add SensorState
    add Singleton template
  * XM-430 / CM-740 device file added.
    Sensor device added.
  * added code to support the gazebo simulator
  * added first bulk read failure protection code
  * renewal
  * Contributors: Alexander Stumpf, Jay Song, Zerom, Pyo

 -- pyo <pyo@robotis.com>  Thu, 11 Aug 2016 15:00:00 -0000

=== debian/control ===
Source: ros-kinetic-robotis-controller
Section: misc
Priority: extra
Maintainer: Pyo <pyo@robotis.com>
Build-Depends: debhelper (>= 9.0.0), libyaml-cpp-dev, ros-kinetic-catkin, ros-kinetic-cmake-modules, ros-kinetic-dynamixel-sdk, ros-kinetic-robotis-controller-msgs, ros-kinetic-robotis-device, ros-kinetic-robotis-framework-common, ros-kinetic-roscpp, ros-kinetic-roslib, ros-kinetic-sensor-msgs, ros-kinetic-std-msgs
Homepage: http://wiki.ros.org/robotis_controller
Standards-Version: 3.9.2

Package: ros-kinetic-robotis-controller
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libyaml-cpp-dev, ros-kinetic-cmake-modules, ros-kinetic-dynamixel-sdk, ros-kinetic-robotis-controller-msgs, ros-kinetic-robotis-device, ros-kinetic-robotis-framework-common, ros-kinetic-roscpp, ros-kinetic-roslib, ros-kinetic-sensor-msgs, ros-kinetic-std-msgs
Description: robotis_controller package for ROBOTIS's platform like Manipulator-H, THORMANG and OP series

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
export DH_OPTIONS=-v --buildsystem=cmake
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/kinetic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh  $@

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/kinetic" \
		-DCMAKE_PREFIX_PATH="/opt/ros/kinetic"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-kinetic-robotis-controller//opt/ros/kinetic/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_install
